Index: branch/gresset/sp4c12/SP4C12/SessionM32C_E8a_SYSTEM.ini
===================================================================
--- branch/gresset/sp4c12/SP4C12/SessionM32C_E8a_SYSTEM.ini	(revision 882)
+++ branch/gresset/sp4c12/SP4C12/SessionM32C_E8a_SYSTEM.ini	(revision 883)
@@ -25,4 +25,4 @@
 [Target]
 M32C E8a SYSTEM=Renesas Communications
 [USER_DATA]
-RESET=fe0088
+RESET=fe0000
Index: branch/gresset/sp4c12/SP4C12/SessionM32C_E8a_SYSTEM.hsf
===================================================================
--- branch/gresset/sp4c12/SP4C12/SessionM32C_E8a_SYSTEM.hsf	(revision 882)
+++ branch/gresset/sp4c12/SP4C12/SessionM32C_E8a_SYSTEM.hsf	(revision 883)
@@ -45,7 +45,7 @@
 "{55384715-F881-421C-A548-D7D1ABE158E1}PDMRCtrlViews" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_DENORMAL_MODE" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_ROUND_MODE" "0" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "0000000000000024" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "0000000000000001" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_1" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_10" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_11" "0000000000000000" 
@@ -53,12 +53,12 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_13" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_14" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_15" "0000000000000400" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE0367" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE032F" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_17" "0000000000FFFD00" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "0000000000000788" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_19" "0000000000000A88" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "0000000000000758" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_19" "0000000000000A66" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_2" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000088" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000084" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_21" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_22" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_23" "0000000000000000" 
@@ -75,9 +75,9 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_33" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_34" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_35" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_4" "0000000000FE0088" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_4" "0000000000FE0000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_5" "0000000000020000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_6" "0000000000000000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_6" "000000000000075E" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_7" "0000000000000400" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_8" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_9" "0000000000000000" 
@@ -106,13 +106,19 @@
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth0" "120" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth1" "257" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth12" "150" 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth2" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth2" "152" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth3" "200" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000" "etat, 10, 0, P, Col, Hex, N" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000_SCOPE" "Current Scope," 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001" "buffer, 6, 0, P, Col, Hex, MA" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001" "*buffer, 10, 0, P, Col, Hex, N" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001_SCOPE" "Current Scope," 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "2" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0002" "buffer, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0002_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0003" "i, 1, 0, P, Col, Hex, MA" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0003_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0004" "trame, 6, 0, P, Col, Hex, MA" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0004_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "5" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth0" "120" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth1" "150" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth12" "150" 
@@ -718,7 +724,7 @@
 "{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd0Exp98" "0" 
 "{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd0Exp99" "0" 
 "{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd0ScrollHorz" "0" 
-"{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd0ScrollVert" "391" 
+"{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd0ScrollVert" "548" 
 "{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd1ColWidth0" "200" 
 "{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd1ColWidth1" "100" 
 "{F866DB60-6186-11D5-8BBE-0004E2013C71}IOWnd1ColWidth2" "100" 
@@ -737,9 +743,9 @@
 0 
 [WINDOW_POSITION_STATE_DATA_VD1]
 "Help" "TOOLBAR 0" 59419 1 5 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_00000001_IO}SP4C12SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 1 "0.09" 332 0 0 350 200 18 0 "32817|32826|32819|32820|32821" "0.0" 
-"{WK_00000001_OUTPUT}" "WINDOW" 59422 0 2 "0.41" 332 683 371 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
-"{WK_00000001_WATCH}SP4C12SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 0 "0.50" 332 0 0 350 200 18 0 "32781|32783|<<separator>>|32771|32829|32772|32827|32773|<<separator>>|32786|<<separator>>|32810|32811|32831" "0.0" 
+"{WK_00000001_IO}SP4C12SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 2 "0.01" 332 0 0 350 200 18 0 "32817|32826|32819|32820|32821" "0.0" 
+"{WK_00000001_OUTPUT}" "WINDOW" 59422 0 1 "0.50" 332 683 371 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
+"{WK_00000001_WATCH}SP4C12SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 0 "0.49" 332 0 0 350 200 18 0 "32781|32783|<<separator>>|32771|32829|32772|32827|32773|<<separator>>|32786|<<separator>>|32810|32811|32831" "0.0" 
 "{WK_00000002_WORKSPACE}" "WINDOW" 59420 0 0 "1.00" 180 683 371 350 200 18 0 "" "0.0" 
 "{WK_TB00000001_STANDARD}" "TOOLBAR 0" 59419 0 2 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
 "{WK_TB00000002_EDITOR}" "TOOLBAR 0" 59419 0 0 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
Index: branch/gresset/sp4c12/SP4C12/ncrt0.a30
===================================================================
--- branch/gresset/sp4c12/SP4C12/ncrt0.a30	(revision 882)
+++ branch/gresset/sp4c12/SP4C12/ncrt0.a30	(revision 883)
@@ -148,6 +148,7 @@
 ;---------------------------------------------------------------------
 ; after reset,this program will start
 ;---------------------------------------------------------------------
+;
 	ldc	#istack_top,	isp	;set istack pointer
 	mov.b	#02h,0ah
 	mov.b	#00h,04h		;set processer mode 
Index: branch/gresset/sp4c12/SP4C12/SP4C12.c
===================================================================
--- branch/gresset/sp4c12/SP4C12/SP4C12.c	(revision 882)
+++ branch/gresset/sp4c12/SP4C12/SP4C12.c	(revision 883)
@@ -10,18 +10,22 @@
 /***********************************************************************/
 #include "sfr32c87.h"
 
+//Initialisation du port 1
 void init_led(void){
-	pd1=0b11111111;
-	p1=0b00000000;
+	pd1=0b11111111;		//Toutes les broches sont mises en sortie
+	p1=0b00000000;		//Toutes les broches sont mises à 0
 }	
 
+//Initialisation des registres permettant la communication par l'UART0
 void uart0_init(void){
-	
+
+//Initialisation des registres de l'UART0	
 	u0mr=0b00000101;
 	u0brg=0b00100000;
 	u0c0=0b00001001;
 	u0c1=0b00010101;
-		
+
+//Initialisation des broches du PORT6 sur lesquelles est relié l'UART		
 	pd6_0=0;
 	pd6_1=0;
 	pd6_2=0;
@@ -41,32 +45,60 @@
 
 
 char uart0_rx(){
-	while (ri_u0c1!=0);
+	while (ri_u0c1!=1);
 		return u0rb;
 }
 
-char buffer[128]=0, trame[]="$GPGGA*";
+
 //Test de uart0_rx() :
-void main(void)
+/*void test_uart0_rx()
 {
-	int etat=0, i=0;
 	
 	uart0_init();
 	init_led();
 	
-	if((trame[i])=='$'){
+	if((uart0_rx())=='$'){
 		p1=0xff;
-		while((trame[i])!='*'){
-			buffer[i]=trame[i];
-			i++;
-		}		
 	}
 	if((uart0_rx())=='*'){
 		p1=0x0f;
 	}
+}*/
+
+char trame[100];
+int i;
+
+//Fonction rec_trame sans machine d'etat ni interruptions
+int rec_trame (char trame[]){
 	
-}	
+	char car;
+	i=0;
+	uart0_init();
+	
+	while(1){
+		if((uart0_rx())=='$'){
+			car=uart0_rx();
+			while(car!='*'){
+				trame[i]=car;
+				i++;
+				car=uart0_rx();
+			}
+		}
+	}	
+	return i;
+}
+//conversion d'un hexadécimal en entier (ne fonctionne pas
+int hex2int (char c[]){
+	int entier=0;
+	entier=(c[1]-48)*16+(c[0]-48);
+	return entier;
+}
 
+void main (void){
+	
+	
+}
+
 //Affiche l'alphabet en continu
 /*void main(void)
 {