Index: branch/MBADINGA/sp4c12/Sp4c12/SessionM32C_E8a_SYSTEM.hsf
===================================================================
--- branch/MBADINGA/sp4c12/Sp4c12/SessionM32C_E8a_SYSTEM.hsf	(revision 910)
+++ branch/MBADINGA/sp4c12/Sp4c12/SessionM32C_E8a_SYSTEM.hsf	(revision 911)
@@ -22,7 +22,9 @@
 "{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineCtrlBrowseDirectory" "" 
 "{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineCtrlLogFileName" "" 
 "{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineCtrlSplitterPosition" "242" 
-"{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineCtrlViews" "0" 
+"{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineCtrlViews" "1" 
+"{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineCtrlWindowProperties" "17" 
+"{313F4FC1-6566-11D5-8BBE-0004E2013C71}CmdLineWndInstanceKey0" "{WK_00000001_CmdLine}" 
 "{313F4FC1-6566-11D5-8BBE-0004E2013C71}TclTkCtrlLogFileName" "" 
 "{313F4FC2-6566-11D5-8BBE-0004E2013C71}ECX_MEMORY_COMPARE_END_ADDRESS" "" 
 "{313F4FC2-6566-11D5-8BBE-0004E2013C71}ECX_MEMORY_COMPARE_START_ADDRESS" "" 
@@ -45,7 +47,7 @@
 "{55384715-F881-421C-A548-D7D1ABE158E1}PDMRCtrlViews" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_DENORMAL_MODE" "0" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_EVAL_ROUND_MODE" "0" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "0000000000000000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_0" "0000000000000001" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_1" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_10" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_11" "0000000000000000" 
@@ -52,13 +54,13 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_12" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_13" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_14" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_15" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE0000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_17" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_19" "0000000000000500" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_15" "0000000000000400" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_16" "0000000000FE032E" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_17" "0000000000FFFD00" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_18" "00000000000006F2" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_19" "0000000000000A00" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_2" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_20" "0000000000000084" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_21" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_22" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_23" "0000000000000000" 
@@ -75,10 +77,10 @@
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_33" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_34" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_35" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_4" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_5" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_6" "0000000000000000" 
-"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_7" "0000000000000000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_4" "0000000000FE0000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_5" "0000000000020000" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_6" "00000000000006F4" 
+"{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_7" "0000000000000400" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_8" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_9" "0000000000000000" 
 "{64753FED-D387-4B8C-A91D-D3419C869C07}C_REGISTER_REG_COUNT" "36" 
@@ -102,8 +104,37 @@
 "{AC411480-6F0A-11D5-8EB6-00004CC34E9D}ECX_IMAGE_SAMPLEING_RATE" "1000" 
 "{AC411480-6F0A-11D5-8EB6-00004CC34E9D}ECX_IMAGE_VIEW" "0,0,0,0,0,0" 
 "{AC411480-6F0A-11D5-8EB6-00004CC34E9D}ImageCtrlViews" "0" 
-"{B266D880-6FA1-11D5-8613-00A024591A38}WatchCtrlViews" "0" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchCtrlViews" "4" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth0" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth1" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth12" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth2" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ColWidth3" "200" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000" "c, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0000_SCOPE" "Global," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001" "u0rb, 10, 0, P, Col, Hex, N" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEM0001_SCOPE" "Current Scope," 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd0ECX_WATCH_ITEMCnt" "2" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth0" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth1" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth12" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth2" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ColWidth3" "200" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd1ECX_WATCH_ITEMCnt" "0" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd2ColWidth0" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd2ColWidth1" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd2ColWidth12" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd2ColWidth2" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd2ColWidth3" "200" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd2ECX_WATCH_ITEMCnt" "0" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd3ColWidth0" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd3ColWidth1" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd3ColWidth12" "150" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd3ColWidth2" "120" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd3ColWidth3" "200" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWnd3ECX_WATCH_ITEMCnt" "0" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWndInitial_Radix" "0" 
+"{B266D880-6FA1-11D5-8613-00A024591A38}WatchWndInstanceKey0" "{WK_00000001_WATCH}Sp4c12SessionM32C_E8a_SYSTEM" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWndRecentFile_WatchRecord" "" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWndRecentFile_WatchSave" "" 
 "{B266D880-6FA1-11D5-8613-00A024591A38}WatchWndUpdate_Interval" "100" 
@@ -136,7 +167,9 @@
 0 
 [WINDOW_POSITION_STATE_DATA_VD1]
 "Help" "TOOLBAR 0" 59419 1 5 "0.00" 0 0 0 0 0 17 0 "" "0.0" 
-"{WK_00000001_OUTPUT}" "WINDOW" 59422 0 0 "1.00" 180 534 287 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
+"{WK_00000001_CmdLine}" "WINDOW" 59422 0 2 "0.33" 180 0 0 350 200 17 0 "32771|32772|32778|<<separator>>|32773|32774|<<separator>>|32820|<<separator>>|32801|32824" "0.0" 
+"{WK_00000001_OUTPUT}" "WINDOW" 59422 0 1 "0.59" 180 534 287 350 200 18 0 "36756|36757|36758|36759|<<separator>>|36746|36747|<<separator>>|39531|<<separator>>|39500|39534|<<separator>>|36687" "0.0" 
+"{WK_00000001_WATCH}Sp4c12SessionM32C_E8a_SYSTEM" "WINDOW" 59422 0 0 "0.41" 180 1600 -533 350 200 18 0 "32781|32783|<<separator>>|32771|32829|32772|32827|32773|<<separator>>|32786|<<separator>>|32810|32811|32831" "0.0" 
 "{WK_00000002_WORKSPACE}" "WINDOW" 59420 0 0 "1.00" 180 534 287 350 200 18 0 "" "0.0" 
 "{WK_TB00000001_STANDARD}" "TOOLBAR 0" 59419 0 2 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
 "{WK_TB00000002_EDITOR}" "TOOLBAR 0" 59419 0 0 "0.00" 0 0 0 0 0 18 0 "" "0.0" 
@@ -160,12 +193,14 @@
 [WINDOW_POSITION_STATE_DATA_VD3]
 [WINDOW_POSITION_STATE_DATA_VD4]
 [WINDOW_Z_ORDER]
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\Sp4c12.c" 
-"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.c" 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.h" 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\ncrt0.a30" 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\sect308.inc" 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.h" 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\sfr32c87.h" 
-"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\ncrt0.a30" 
-"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\sect308.inc" 
 [TARGET_NAME]
 "M32C E8a SYSTEM" "" 0 
 [STATUSBAR_STATEINFO_VD1]
Index: branch/MBADINGA/sp4c12/Sp4c12/Sp4c12.hwp
===================================================================
--- branch/MBADINGA/sp4c12/Sp4c12/Sp4c12.hwp	(revision 910)
+++ branch/MBADINGA/sp4c12/Sp4c12/Sp4c12.hwp	(revision 911)
@@ -107,6 +107,8 @@
 [PROJECT_FILES]
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\Sp4c12.c" "User" "C source file" 2 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\ncrt0.a30" "User" "Assembly source file" 2 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.c" "User" "C source file" 2 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.h" "User" "C header file" 2 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" "User" "C source file" 2 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.h" "User" "C header file" 2 
 [FOLDER]
@@ -130,15 +132,16 @@
 [OPTIONS_Debug_Renesas M32C C Compiler]
 "C source file" "08df220a6c657d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\Sp4c12.c" "08df220a6c657d10" 1 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.c" "0469b5c9e0e57d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" "03a728c8bc657d10" 1 
 [OPTIONS_Debug_Renesas M32C Configurator]
-"Single Shot" "03a728c8bc657d10" 6 
+"Single Shot" "0469b5c9e0e57d10" 6 
 [OPTIONS_Debug_Renesas M32C Librarian]
-"Single Shot" "03a728c8bc657d10" 5 
+"Single Shot" "0469b5c9e0e57d10" 5 
 [OPTIONS_Debug_Renesas M32C Linker]
-"Single Shot" "03be48c8bc657d10" 3 
+"Single Shot" "0469b5c9e0e57d10" 3 
 [OPTIONS_Debug_Renesas M32C Stype Converter]
-"Single Shot" "03be48c8bc657d10" 4 
+"Single Shot" "0469b5c9e0e57d10" 4 
 [OPTIONS_Debug]
 "" 0 
 "[V|VERSION|1] [B|COMMAND|1] [S|SPEC|UITRON3] " 6 
@@ -157,15 +160,16 @@
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C C Compiler]
 "C source file" "08df220a6c657d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\Sp4c12.c" "08df220a6c657d10" 1 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.c" "0469b5c9e0e57d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" "03a728c8bc657d10" 1 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Configurator]
-"Single Shot" "03a728c8bc657d10" 6 
+"Single Shot" "0469b5c9e0e57d10" 6 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Librarian]
-"Single Shot" "03a728c8bc657d10" 5 
+"Single Shot" "0469b5c9e0e57d10" 5 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Linker]
-"Single Shot" "03be48c8bc657d10" 3 
+"Single Shot" "0469b5c9e0e57d10" 3 
 [OPTIONS_Debug_M32C_E8a_SYSTEM_Renesas M32C Stype Converter]
-"Single Shot" "03be48c8bc657d10" 4 
+"Single Shot" "0469b5c9e0e57d10" 4 
 [OPTIONS_Debug_M32C_E8a_SYSTEM]
 "" 0 
 "[V|VERSION|1] [B|COMMAND|1] [S|SPEC|UITRON3] " 6 
@@ -184,15 +188,16 @@
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C C Compiler]
 "C source file" "08df220a6c657d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\Sp4c12.c" "08df220a6c657d10" 1 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.c" "0469b5c9e0e57d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" "03a728c8bc657d10" 1 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Configurator]
-"Single Shot" "03a728c8bc657d10" 6 
+"Single Shot" "0469b5c9e0e57d10" 6 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Librarian]
-"Single Shot" "03a728c8bc657d10" 5 
+"Single Shot" "0469b5c9e0e57d10" 5 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Linker]
-"Single Shot" "03be48c8bc657d10" 3 
+"Single Shot" "0469b5c9e0e57d10" 3 
 [OPTIONS_Debug_M32C_Simulator_Renesas M32C Stype Converter]
-"Single Shot" "03be48c8bc657d10" 4 
+"Single Shot" "0469b5c9e0e57d10" 4 
 [OPTIONS_Debug_M32C_Simulator]
 "" 0 
 "[V|VERSION|1] [B|COMMAND|1] [S|SPEC|UITRON3] " 6 
@@ -211,15 +216,16 @@
 [OPTIONS_Release_Renesas M32C C Compiler]
 "C source file" "08df220a6c657d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\Sp4c12.c" "08df220a6c657d10" 1 
+"D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\rectrame.c" "0469b5c9e0e57d10" 1 
 "D:\TP_SP4_MBADINGA_IBOUILI_DAN\sp4c12\Sp4c12\uart0.c" "03a728c8bc657d10" 1 
 [OPTIONS_Release_Renesas M32C Configurator]
-"Single Shot" "03a728c8bc657d10" 6 
+"Single Shot" "0469b5c9e0e57d10" 6 
 [OPTIONS_Release_Renesas M32C Librarian]
-"Single Shot" "03a728c8bc657d10" 5 
+"Single Shot" "0469b5c9e0e57d10" 5 
 [OPTIONS_Release_Renesas M32C Linker]
-"Single Shot" "03be48c8bc657d10" 3 
+"Single Shot" "0469b5c9e0e57d10" 3 
 [OPTIONS_Release_Renesas M32C Stype Converter]
-"Single Shot" "03be48c8bc657d10" 4 
+"Single Shot" "0469b5c9e0e57d10" 4 
 [OPTIONS_Release]
 "" 0 
 "[V|VERSION|1] [B|COMMAND|1] [S|SPEC|UITRON3] " 6 
Index: branch/MBADINGA/sp4c12/Sp4c12/uart0.c
===================================================================
--- branch/MBADINGA/sp4c12/Sp4c12/uart0.c	(revision 910)
+++ branch/MBADINGA/sp4c12/Sp4c12/uart0.c	(revision 911)
@@ -1,67 +1,35 @@
 #include  "sfr32c87.h"
 
-void uart0_init(void)
-{
-	smd0_u0mr=1;
-	smd1_u0mr=0;
-	smd2_u0mr=1;
-	ckdir_u0mr=0;
-	stps_u0mr=0;
-	prye_u0mr=0;
-	iopol_u0mr=0;
-	u0smr=0x00;
-	u0smr2=0x00;
-	u0smr3=0x00;
-	u0smr4=0x00;
 
-
-	clk0_u0c0=0;
-	clk1_u0c0=0;
-	crd_u0c0=1;
-	crs_u0c0=0;
-	nch_u0c0=0;
-	ckpol_u0c0=0;
-	uform_u0c0=0;
-	txept_u0c0=0;
-
-	u0brg=255;
-
-	te_u0c1=0;
-	re_u0c1=0;
-	ti_u0c1=1;
-	ri_u0c1=0;
-	u0rrm_u0c1=0;
-	u0lch_u0c1=0;
-	
-	//bit 7=0
-	u0c1=u0c1 & 0x7f;
-
-	pd6_0=0;
-	pd6_1=0;
-	pd6_2=0;
-	pd6_3=1;
-
-	ps0_0=0;
-	ps0_1=0;
-	ps0_2=0;
-	ps0_3=1;
-	psl0_0=0;
-
-}
-
+void uart0_init (void)
+    {
+        
+		//initialisation des ports
+        pd6_1 = 0 ;    
+        pd6_2 = 0;
+        pd6_3 = 1;
+        ps0_1 = 0;
+        ps0_2 = 0;
+        ps0_3 = 1;
+		
+		//initialisation des registres
+        u0mr = 0x05;
+        u0brg = 0x20;
+        u0c0 = 0x11;
+        u0c1 = 0x05;
+    }
+       
 void uart0_tx(char c)
-{ 
-   	ti_u0c1=0;
-	while(ri_u0c1!=1);
-	u0tb=c;
-	
-}
-
-char uart0_rx(void)
-{
-	psl0_0=1;
-	while(ri_u0c1!=1);
-	return u0rb;
-	
-	
-}
\ No newline at end of file
+    {
+   		while(ti_u0c1 !=1);
+   		u0tb=c;
+    }
+    
+char uart0_rx()
+    {
+		char c;
+        while(ri_u0c1!=1);
+		c=u0rb;
+		uart0_tx(c);
+        return c;
+    }
Index: branch/MBADINGA/sp4c12/Sp4c12/Sp4c12.c
===================================================================
--- branch/MBADINGA/sp4c12/Sp4c12/Sp4c12.c	(revision 910)
+++ branch/MBADINGA/sp4c12/Sp4c12/Sp4c12.c	(revision 911)
@@ -11,14 +11,25 @@
 
 #include  "sfr32c87.h"
 #include  "uart0.h"
+#include  "rectrame.h"
 
-
-
+char Buffer[];
 void main(void)
 {
-	char c='A';
-	int i;
-	uart0_init();
-	uart0_tx(c);
+    char c;
+    uart0_init();
+   while(1)
+   
+	{	
+        /*int i=0;
+		{
+			for (i=0;i<26;i++)
+        	uart0_tx(c+i);
+		}*/
+    	uart0_rx();
+	}
+
 	
 }
+
+